# digitale-verwaltung
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >= 3.6

## Installation & Usage
### pip install

```sh
pip install deutschland[digitale_verwaltung]
```

### poetry install

```sh
poetry add deutschland -E digitale_verwaltung
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

## Usage

Import the package:
```python
from deutschland import digitale_verwaltung
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
from deutschland import digitale_verwaltung
from pprint import pprint
from deutschland.digitale_verwaltung.api import ars_api
from deutschland.digitale_verwaltung.model.page_ars_dto import PageArsDto
# Defining the host is optional and defaults to https://dashboard-daten.digitale-verwaltung.de/api
# See configuration.py for a list of all supported configuration parameters.
configuration = digitale_verwaltung.Configuration(
    host = "https://dashboard-daten.digitale-verwaltung.de/api"
)



# Enter a context with an instance of the API client
with digitale_verwaltung.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ars_api.ARSApi(api_client)
    order = "asc" # str | Gibt an, wie die Ergebnismenge sortiert werden soll. (optional) (default to "asc")
    page = "0" # str | Gibt an, welche Seite der Ergebnismenge zurückgegeben werden soll. Die erste Seite entspricht dem Wert 0. (optional) (default to "0")
    size = "100" # str | Gibt an, wie groß die Ergebnismenge für die abgefragte Seite maximal sein darf. (optional) (default to "100")

    try:
        # Informationen zu Gebietskörperschaften in Deutschland
        api_response = api_instance.find_all1(order=order, page=page, size=size)
        pprint(api_response)
    except digitale_verwaltung.ApiException as e:
        print("Exception when calling ARSApi->find_all1: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://dashboard-daten.digitale-verwaltung.de/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ARSApi* | [**find_all1**](docs/ARSApi.md#find_all1) | **GET** /v1/ars | Informationen zu Gebietskörperschaften in Deutschland
*DataApi* | [**find_all**](docs/DataApi.md#find_all) | **GET** /v1/data | Informationen zu OZG-Leistungen und deren zugehörigen Onlinediensten
*DataApi* | [**find_by_filter**](docs/DataApi.md#find_by_filter) | **GET** /v1/data/{ars} | Informationen zu OZG-Leistungen und deren zugehörigen Onlinediensten eingeschränkt auf Gebietskörperschaften


## Documentation For Models

 - [ArsDto](docs/ArsDto.md)
 - [DvDataDto](docs/DvDataDto.md)
 - [PageArsDto](docs/PageArsDto.md)
 - [PageDvDataDto](docs/PageDvDataDto.md)
 - [PageableObject](docs/PageableObject.md)
 - [SortObject](docs/SortObject.md)


## Documentation For Authorization

 All endpoints do not require authorization.

## Author

kontakt@bund.dev


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in digitale_verwaltung.apis and digitale_verwaltung.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from deutschland.digitale_verwaltung.api.default_api import DefaultApi`
- `from deutschland.digitale_verwaltung.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
from deutschland import digitale_verwaltung
from deutschland.digitale_verwaltung.apis import *
from deutschland.digitale_verwaltung.models import *
```

