"""
    API zum Digitalisierungsfortschritt der öffentlichen Verwaltung

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: kontakt@bund.dev
    Generated by: https://openapi-generator.tech
"""

import re  # noqa: F401
import sys  # noqa: F401

from deutschland.digitale_verwaltung.api_client import ApiClient
from deutschland.digitale_verwaltung.api_client import Endpoint as _Endpoint
from deutschland.digitale_verwaltung.model.page_dv_data_dto import PageDvDataDto
from deutschland.digitale_verwaltung.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types,
)


class DataApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.find_all_endpoint = _Endpoint(
            settings={
                "response_type": (PageDvDataDto,),
                "auth": [],
                "endpoint_path": "/v1/data",
                "operation_id": "find_all",
                "http_method": "GET",
                "servers": None,
            },
            params_map={
                "all": [
                    "order",
                    "page",
                    "size",
                ],
                "required": [],
                "nullable": [],
                "enum": [
                    "order",
                ],
                "validation": [],
            },
            root_map={
                "validations": {},
                "allowed_values": {
                    ("order",): {"ASC": "asc", "DESC": "desc"},
                },
                "openapi_types": {
                    "order": (str,),
                    "page": (str,),
                    "size": (str,),
                },
                "attribute_map": {
                    "order": "order",
                    "page": "page",
                    "size": "size",
                },
                "location_map": {
                    "order": "query",
                    "page": "query",
                    "size": "query",
                },
                "collection_format_map": {},
            },
            headers_map={
                "accept": ["application/json"],
                "content_type": [],
            },
            api_client=api_client,
        )
        self.find_by_filter_endpoint = _Endpoint(
            settings={
                "response_type": None,
                "auth": [],
                "endpoint_path": "/v1/data/{ars}",
                "operation_id": "find_by_filter",
                "http_method": "GET",
                "servers": None,
            },
            params_map={
                "all": [
                    "ars",
                    "filetype",
                    "order",
                    "page",
                    "size",
                    "include_above",
                    "include_below",
                ],
                "required": [
                    "ars",
                ],
                "nullable": [],
                "enum": [
                    "filetype",
                    "order",
                    "include_above",
                    "include_below",
                ],
                "validation": [
                    "ars",
                    "filetype",
                ],
            },
            root_map={
                "validations": {
                    ("ars",): {
                        "regex": {
                            "pattern": r"^\d{12}$",  # noqa: E501
                        },
                    },
                    ("filetype",): {
                        "regex": {
                            "pattern": r"csv|xlsx",  # noqa: E501
                        },
                    },
                },
                "allowed_values": {
                    ("filetype",): {"CSV": "csv", "XLSX": "xlsx"},
                    ("order",): {"ASC": "asc", "DESC": "desc"},
                    ("include_above",): {"TRUE": "true", "FALSE": "false"},
                    ("include_below",): {"TRUE": "true", "FALSE": "false"},
                },
                "openapi_types": {
                    "ars": (str,),
                    "filetype": (str,),
                    "order": (str,),
                    "page": (str,),
                    "size": (str,),
                    "include_above": (str,),
                    "include_below": (str,),
                },
                "attribute_map": {
                    "ars": "ars",
                    "filetype": "filetype",
                    "order": "order",
                    "page": "page",
                    "size": "size",
                    "include_above": "includeAbove",
                    "include_below": "includeBelow",
                },
                "location_map": {
                    "ars": "path",
                    "filetype": "query",
                    "order": "query",
                    "page": "query",
                    "size": "query",
                    "include_above": "query",
                    "include_below": "query",
                },
                "collection_format_map": {},
            },
            headers_map={
                "accept": ["application/json", "application/octet-stream"],
                "content_type": [],
            },
            api_client=api_client,
        )

    def find_all(self, **kwargs):
        """Informationen zu OZG-Leistungen und deren zugehörigen Onlinediensten  # noqa: E501

        Liefert Informationen zu OZG-Leistungen und deren zugehörigen Onlinediensten.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.find_all(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            order (str): Gibt an, wie die Ergebnismenge sortiert werden soll.. [optional] if omitted the server will use the default value of "asc"
            page (str): Gibt an, welche Seite der Ergebnismenge zurückgegeben werden soll. Die erste Seite entspricht dem Wert 0.. [optional] if omitted the server will use the default value of "0"
            size (str): Gibt an, wie groß die Ergebnismenge für die abgefragte Seite maximal sein darf.. [optional] if omitted the server will use the default value of "100"
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            PageDvDataDto
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs["async_req"] = kwargs.get("async_req", False)
        kwargs["_return_http_data_only"] = kwargs.get("_return_http_data_only", True)
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")
        kwargs["_request_auths"] = kwargs.get("_request_auths", None)
        return self.find_all_endpoint.call_with_http_info(**kwargs)

    def find_by_filter(self, ars, **kwargs):
        """Informationen zu OZG-Leistungen und deren zugehörigen Onlinediensten eingeschränkt auf Gebietskörperschaften  # noqa: E501

        Liefert Informationen zu OZG-Leistungen und deren zugehörigen Onlinediensten eingeschränkt auf Gebietskörperschaften.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.find_by_filter(ars, async_req=True)
        >>> result = thread.get()

        Args:
            ars (str): Gibt den 12-stelligen amtlichen Regionalschlüssel einer Gebietskörperschaft an.

        Keyword Args:
            filetype (str): Gibt an, in welchem Dateiformat (CSV, XLSX) die Ergebnismenge zurückgegeben werden soll.. [optional] if omitted the server will use the default value of "csv"
            order (str): Gibt an, wie die Ergebnismenge sortiert werden soll.. [optional] if omitted the server will use the default value of "asc"
            page (str): Gibt an, welche Seite der Ergebnismenge zurückgegeben werden soll. Die erste Seite entspricht dem Wert 0.. [optional] if omitted the server will use the default value of "0"
            size (str): Gibt an, wie groß die Ergebnismenge für die abgefragte Seite maximal sein darf.. [optional] if omitted the server will use the default value of "100"
            include_above (str): Gibt an, ob OZG-Leistungen auf darüberliegenden Gebietskörperschaften mit in der Ergebnismenge enthalten sein sollen.. [optional] if omitted the server will use the default value of "true"
            include_below (str): Gibt an, ob OZG-Leistungen auf darunterliegenden Gebietskörperschaften mit in der Ergebnismenge enthalten sein sollen.. [optional] if omitted the server will use the default value of "true"
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs["async_req"] = kwargs.get("async_req", False)
        kwargs["_return_http_data_only"] = kwargs.get("_return_http_data_only", True)
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")
        kwargs["_request_auths"] = kwargs.get("_request_auths", None)
        kwargs["ars"] = ars
        return self.find_by_filter_endpoint.call_with_http_info(**kwargs)
